Subject: R: .libPaths dereferences symbolic links; requires restart after "guix install STUFF"

From: Maxime Devos <[email-masked]>
Date: Sat, 22 May 2021 00:22:56 +0200

Today I started R (from Emacs). I needed mefa::rep.data.frame,
so I ran "guix install r-mefa -p ../prof" (actually guix package
-p ../prof -m ../manifest.scm, but that shouldn't matter for
the purposes of the bug report)

(r-mefa is not in the guix repo yet)

Now it is installed, I typed in the R prompt:

> mefa::rep.data.frame
Error in loadNamespace(name) : there is no package called ‘mefa’

The solution is to exit the R prompt and restart.
Can we do better?

It appears the search path is set with .libPaths:

> .libPaths
function (new) 
{
    if (!missing(new)) {
        new <- Sys.glob(path.expand(new))
        paths <- c(new, .Library.site, .Library)
        paths <- paths[dir.exists(paths)]
        .lib.loc <<- unique(normalizePath(paths, "/"))
    }
    else .lib.loc
}
<bytecode: 0xe39110>
<environment: 0xe32a48>
> .libPaths()
[1] "/gnu/store/5cgx6pkhr300v706sv46gx9ypnwanngw-profile/site-library"         
[2] "/gnu/store/6laxfxgjxnisi5fzhvqv82wjrgs7q0md-r-minimal-4.0.4/lib/R/library"

It seems like the symbolic link of ../prof is dereferenced to
/gnu/store/5cgx6pkhr300v706sv46gx9ypnwanngw-profile.

Promising is the documentation (? base::normalizePath) of base::normalizePath:

     [...]
     Where the Unix-alike platform supports it attempts to turn paths
     into absolute paths in their canonical form (no ‘./’, ‘../’ nor
     **symbolic links**). [...] (emphasis mine)

Maybe we make a copy of normalizePath (base:::guix_normalizeLibraryPath?) doing
the same as base::normalizePath but without dereferencing symbolic links,
and adjust .libPaths to use our variant base:::guix_normalizeLibraryPath instead
of normalizePath?

Greetings,
Maxime.